function l = ge(varargin)

% Overloads the >= operator for dseries objects.

% Copyright © 2021-2023 Dynare Team
%
% This code is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% Dynare dates submodule is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with Dynare.  If not, see <https://www.gnu.org/licenses/>.

if isreal(varargin{2}) && isdseries(varargin{1})
    l = varargin{1}.data>=varargin{2};
elseif isreal(varargin{1}) && isdseries(varargin{2})
    l = varargin{1}>=varargin{2}.data;
elseif isdseries(varargin{1}) && isdseries(varargin{2})
    l = varargin{1}.data>=varargin{2}.data;
else
    error('dseries::ge: wrong types.')
end
